; Osluneni 0.5 Beta pro 4MCAD
; K dispozici k uzivani dle licence GNU GPL v.3
; Autor neodpovida za vady software (je doporucena verifikace vysledku i jinou metodou).

(defun C:SS(/ delka konvergence sirka deklinace hodinovy_uhel vyska_slunce vyska_slunce_st 
azimut azimut_vychod azimut_zapad cas p0 p1 p2 pv x0 x1 x2 y0 y1 y2 
deltax1 deltay1 deltax2 deltay2 uhel1 uhel2 pocuhel konuhel temp 
zacatek konec delka delkaosluneni en en1 entlist ob1 ob2 ob3 vx vy vz hypot sel ct 
delka_stupne delka_minuty den mesic casovy_interval interval_temp vykreslovat_paprsky
pointlist1 pointlist2 pointlist3 i)         

	(setvar "cmdecho" 0)
	
	(setq flag 5)
	(setq Dcl_Id% (load_dialog "osluneni052.dcl"))
	  
	(while (> flag 2)
	 
	  (if (not (new_dialog "osluneni" Dcl_Id%))
		(exit)
	  )
	  
	  (set_tile "Title" "Osluneni 0.52")
	  
	  (setq mestajmena '("Brno" "Ceske Budejovice" "Hradec Kralove" "Jihlava" "Karlovy Vary" "Liberec" "Olomouc" "Ostrava" "Pardubice" "Plzen" "Praha" "Usti n. Labem" "Zlin" "vlastni nastaveni"))
	  (setq stupne '("16" "14" "15" "15" "12" "15" "17" "18" "15" "13" "14" "14" "17" ""))
	  (setq minuty '("37" "29" "50" "35" "53" "03" "15" "17" "47" "22" "24" "02" "40" ""))
	  (setq mesice '("leden" "unor" "brezen" "duben" "kveten" "cerven" "cervenec" "srpen" "zari" "rijen" "listopad" "prosinec"))
	  (setq dny '("1" "2" "3" "4" "5" "6" "7" "8" "9" "10" "11" "12" "13" "14" "15" "16" "17" "18" "19" "20" "21" "22" "23" "24" "25" "26" "27" "28" "29" "30" "31"))
	  
	  (start_list "mesta" 3)
		(mapcar 'add_list mestajmena)
	  (end_list)
	  
	  (start_list "day" 3)
		(mapcar 'add_list dny)
	  (end_list)
	  
	  (start_list "mon" 3)
		(mapcar 'add_list mesice)
	  (end_list)
	  
	  (set_tile "st" (setq item (nth 0 stupne)))
	  (set_tile "min" (setq item (nth 0 minuty)))
	  (set_tile "day" "0")
	  (set_tile "mon" "2")
	  (set_tile "int" "5")
	  (set_tile "rays" "15")
	  (set_tile "textsize" "1000")
	  
	  (action_tile "mesta"
		"(set_tile \"st\" (setq item (nth (atoi $value) stupne)))
		(set_tile \"min\" (setq item (nth (atoi $value) minuty)))
		" 
	  )
	  
	  (action_tile "st"
		"(set_tile \"mesta\" \"13\")" 
	  )
	  
	  (action_tile "min"
		"(set_tile \"mesta\" \"13\")" 
	  )
	  
	  (action_tile "accept"
	   "(setq delka_stupne (atof (get_tile \"st\")))
	   (setq delka_minuty (atof (get_tile \"min\")))
	   (setq mesic (1+ (atoi (get_tile \"mon\"))))
	   (setq den (1+ (atoi (get_tile \"day\"))))
	   (setq fasada (atof (get_tile \"fasada\")))
	   (setq pozemek (atof (get_tile \"pozemek\")))
	   (setq casovy_interval (atof (get_tile \"int\")))
	   (setq vykreslovat_paprsky (atof (get_tile \"rays\")))
	   (setq textsize (atof (get_tile \"textsize\")))
	   
	   (done_dialog)
	   (setq result T)"
	   )
  
	  (setq flag (start_dialog))
	  
	)
	
	(setq casovy_interval (six2ten casovy_interval))
	(setq vykreslovat_paprsky (six2ten vykreslovat_paprsky))
	
	(setq pointlist1 '())
	(setq pointlist2 '())
	(setq pointlist3 '())
	
	(if (= pozemek 1)
	(progn
		(while (setq p0 (getpoint "\nZadejte body pro analyzu osluneni: "))
			(setq pointlist1 (cons p0 pointlist1))
			(setq x0 (car p0))
			(setq y0 (cadr p0))
			(setq z0 (caddr p0))
			(setq x1 (+ x0 10))
			(setq y1 (+ y0 100))
			(setq x2 (- x0 10))
			(setq p1 (list x1 y1 z0))
			(setq p2 (list x2 y1 z0))
			(setq pointlist2 (cons p1 pointlist2))
			(setq pointlist3 (cons p2 pointlist3))
		)
	))
	
	(if (= fasada 1)
	(progn
		(while (and
			(setq p0 (getpoint "\nZadejte bod pro analyzu osluneni: "))
			(setq p1 (getpoint "\nZadejte smer 1 (min. uhel 25 st. od fasady): "))
			(setq p2 (getpoint "\nZadejte smer 2 (min. uhel 25 st. od fasady): "))
		)
			(setq pointlist1 (cons p0 pointlist1))
			(setq pointlist2 (cons p1 pointlist2))
			(setq pointlist3 (cons p2 pointlist3))
		)
	))
	
	(setq pointlist1 (reverse pointlist1))
	(setq pointlist2 (reverse pointlist2))
	(setq pointlist3 (reverse pointlist3))
	
	(setq sel nil)
	(princ "\nVyberte stinici prekazky: ")
	(setq sel (ssget))
	
	;Vypocet meridianove konvergence dle zemepisne delky
	(setq delka (+ delka_stupne (six2ten delka_minuty)))
	(setq konvergence (/ (- (+ 24 (six2ten 50.0)) delka) 1.34))
	(setq konvergence (deg2rad konvergence))
	
	;Pevne nastaveni zemepisne sirky
	(setq sirka (deg2rad 50.0))
	
	(setq deklinace (* 23.45 (sin (deg2rad (+ (* 0.98 den) (* 29.7 mesic) -109)))))
	(setq deklinace (deg2rad deklinace))
	
	;(if sel
	;(progn
  ;  (princ "\nPocet prekazek: ")
  ;  (princ (sslength sel))
	;))
	;(princ "\nZemepisna delka: ")
	;(princ delka)
	;(princ "\nKonvergence: ")
	;(princ konvergence)
	;(princ "\nDeklinace: ")
	;(princ deklinace)
	
	(setq azimut_zapad (/ (* -1 (sin deklinace) (cos sirka))))
	(setq azimut_zapad (acos azimut_zapad))
	(if (< azimut_zapad 0) (setq azimut_zapad (* -1 azimut_zapad)))
	(setq azimut_vychod (* -1 azimut_zapad))
	
	(setq azimut_vychod (+ azimut_vychod konvergence))
	(setq azimut_zapad (+ azimut_zapad konvergence))
	
	;(princ "\nAzimut vychod: ")
	;(princ (rad2deg azimut_vychod))
	;(princ "\nAzimut zapad: ")
	;(princ (rad2deg azimut_zapad))
	
	;(princ "\nPocet bodu na fasade: ")
	;(princ (length pointlist1))
	;(princ "\nBod na fasade: ")
	;(princ (nth 0 pointlist1))
	;(exit)
	
	(setq i 0)
	(repeat (length pointlist1)
	
		(setq p0 (nth i pointlist1))
		(setq p1 (nth i pointlist2))
		(setq p2 (nth i pointlist3))
		
		(setq x0 (car p0))
		(setq x1 (car p1))
		(setq x2 (car p2))
		(setq y0 (cadr p0))
		(setq y1 (cadr p1))
		(setq y2 (cadr p2))
		(setq z0 (caddr p0))
		(setq deltax1 (- x1 x0))
		(setq deltax2 (- x2 x0))
		(setq deltay1 (- y1 y0))
		(setq deltay2 (- y2 y0))
		(if (and (= deltax1 0) (> deltay1))
			(setq uhel1 pi)
			(setq uhel1 0)
		)
		(if (and (= deltax2 0) (> deltay2))
			(setq uhel2 pi)
			(setq uhel2 0)
		)
		
		(if (and (> deltax1 0) (> deltay1 0))
				(setq uhel1 (* -1 (+ (atan (/ deltay1 deltax1)) (/ pi 2))))
		)
		(if (and (> deltax1 0) (< deltay1 0))
				(setq uhel1 (* -1 (+ (atan (/ deltay1 deltax1)) (/ pi 2))))
		)
		(if (and (< deltax1 0) (< deltay1 0))
				(setq uhel1 (* -1 (- (atan (/ deltay1 deltax1)) (/ pi 2))))
		)
		(if (and (< deltax1 0) (> deltay1 0))
				(setq uhel1 (* -1 (- (atan (/ deltay1 deltax1)) (/ pi 2))))
		)
		
		(if (and (> deltax2 0) (> deltay2 0))
				(setq uhel2 (* -1 (+ (atan (/ deltay2 deltax2)) (/ pi 2))))
		)
		(if (and (> deltax2 0) (< deltay2 0))
				(setq uhel2 (* -1 (+ (atan (/ deltay2 deltax2)) (/ pi 2))))
		)
		(if (and (< deltax2 0) (< deltay2 0))
				(setq uhel2 (* -1 (- (atan (/ deltay2 deltax2)) (/ pi 2))))
		)
		(if (and (< deltax2 0) (> deltay2 0))
				(setq uhel2 (* -1 (- (atan (/ deltay2 deltax2)) (/ pi 2))))
		)
		
		(if (> uhel1 uhel2)
		(progn
			(setq temp uhel1)
			(setq uhel1 uhel2)
			(setq uhel2 temp)
		))
		
		(if (>= azimut_vychod uhel1)
			(setq pocuhel azimut_vychod)
			(setq pocuhel uhel1)
		)
		(if (<= azimut_zapad uhel2)
			(setq konuhel azimut_zapad)
			(setq konuhel uhel2)
		)
		
		;(princ "\nAzimut vychod: ")
		;(princ (rad2deg azimut_vychod))
		;(princ "\nAzimut zapad: ")
		;(princ (rad2deg azimut_zapad))
		
		;(princ "\nPocatecni uhel: ")
		;(princ (rad2deg pocuhel))
		;(princ "\nKoncovy uhel: ")
		;(princ (rad2deg konuhel))
		
		(princ "\nVyckejte, prosim, na dokonceni analyzy...")
		(command "delay" 500)
		;(exit)
		
		(setq cas 3)
		(setq zacatek 0)
		(setq delka 0)
		(setq konec 0)
		(setq interval_temp 0)
		(while (< cas 22)
		
			;hodinovy_uhel = 15 * (cas - 12)
			(setq hodinovy_uhel (* 15 (- cas 12.0)))
			(setq hodinovy_uhel (deg2rad hodinovy_uhel))
			
			;(princ "\nDeklinace: ")
      ;(princ deklinace)
      ;(princ "\nHodinovy uhel: ")
      ;(princ hodinovy_uhel)
      
			(setq vyska_slunce (+ (* (sin sirka)(sin deklinace)) (* (cos sirka) (cos deklinace) (cos hodinovy_uhel))))
			;(princ "\nVyska slunce: ")
      ;(princ vyska_slunce)
			(setq vyska_slunce (asin vyska_slunce))
			(setq vyska_slunce_st (rad2deg vyska_slunce))
			
			(setq azimut (/ (- (* (sin sirka) (cos deklinace) (cos hodinovy_uhel)) (* (cos sirka) (sin deklinace))) (cos vyska_slunce)))
			(if (> azimut 1) (setq azimut 1))
			(setq azimut (acos azimut))
			(if (< hodinovy_uhel 0) (setq azimut (* -1 azimut)))
			
			;Korekce azimutu dle meridianove konvergence
			(setq azimut (+ azimut konvergence))
			
			(if (and (and (> azimut pocuhel) (< azimut konuhel)) (>= vyska_slunce_st 5))
			(progn
				
				(if (and (>= azimut (* -1 pi)) (< azimut (* -0.5 pi)))
				(progn
					(setq vx (* 50000 (cos (+ azimut (/ pi 2)))))
					(setq vy (* -50000 (sin (+ azimut (/ pi 2)))))
				))
				(if (and (>= azimut (* -0.5 pi)) (< azimut 0))
				(progn
					(setq vx (* -50000 (sin azimut)))
					(setq vy (* -50000 (cos azimut)))
				))
				(if (and (>= azimut 0) (< azimut (* 0.5 pi)))
				(progn
					(setq vx (* -50000 (sin azimut)))
					(setq vy (* -50000 (cos azimut)))
				))
				(if (and (>= azimut (* 0.5 pi)) (< azimut pi))
				(progn
					(setq vx (* -50000 (cos (- azimut (/ pi 2)))))
					(setq vy (* 50000 (sin (- azimut (/ pi 2)))))
				))
				(setq hypot (sqrt (+ (expt vx 2) (expt vy 2))))
				(setq vz (* hypot (tangens vyska_slunce)))
				(setq vx (+ vx x0))
				(setq vy (+ vy y0))
				(setq vz (+ vz z0))
				(setq pv (list vx vy vz))
				
				(setq ct 0)
				(setq prunik 0)
				
				(if sel
				(progn
				(repeat (sslength sel)
					
					(if (= prunik 0)
					(progn
					(setq en (ssname sel ct)) ;get entity name
					(setq en1 (entget en)) ; Get the entity data from the entity name.
					(setq ob1 (cdr (assoc 10 en1)))
					(setq ob2 (cdr (assoc 11 en1)))
					(setq ob3 (cdr (assoc 12 en1)))
					(setq ob4 (cdr (assoc 13 en1)))
					
					(IntersLineTriangle p0 pv ob1 ob2 ob3)			
					(if (= prunik 0) (IntersLineTriangle p0 pv ob2 ob3 ob4))
					(if (= prunik 0) (IntersLineTriangle p0 pv ob3 ob4 ob1))
					(if (= prunik 0) (IntersLineTriangle p0 pv ob2 ob4 ob1))
					
					(setq ct (1+ ct))
					
					))
				) ; end sel group repeat
				
				; Vykresleni paprsku
				(if (and (= prunik 0) (>= interval_temp vykreslovat_paprsky) (> vykreslovat_paprsky 0))
				(progn
					(setq entlist (list '(0 . "LINE") '(6 . "ByLayer") (cons 10 p0) (cons 11 pv)))
					(entmake entlist)
					(setq interval_temp 0)
				))
				
				; Nastaveni casu
				(if (and (= zacatek 0) (= prunik 0))
					(progn
					(setq zacatek cas)
					)
				)
				(if (and (/= zacatek 0) (= prunik 0))
					(progn
					(setq konec cas)
					)
				)
				(if (and (/= zacatek 0) (= prunik 1))
				(progn
					(setq delka (+ delka (- konec zacatek)))
					(setq zacatek 0)
					(setq konec 0)
				))
				
				)
				(progn
					(if (= zacatek 0)
						(setq zacatek cas)
						(setq konec cas)
					)
					; Vykresleni paprsku
					(if (and (> vykreslovat_paprsky 0) (>= interval_temp vykreslovat_paprsky) (> vykreslovat_paprsky 0))
					(progn
							(setq entlist (list '(0 . "LINE") '(6 . "ByLayer") (cons 10 p0) (cons 11 pv)))
							(entmake entlist)
							(setq interval_temp 0)
					))
				)
				)
			
			)
			)
			
			(setq cas (+ cas casovy_interval))
			(setq interval_temp (+ interval_temp casovy_interval))
		)
		
		(setq delka (+ delka (- konec zacatek)))

		(princ "\nCelkova doba osluneni: ")
		(setq delkaosluneni (ten2time delka))
		(princ delkaosluneni)
		(command "text" p0 textsize "0" delkaosluneni)
		
		(setq i (1+ i))
	
	) ;repeat length pointlist1 end
	
	(setvar "cmdecho" 1)
	(princ)
)

(defun six2ten (minutes / x)
	(/ minutes 60)
)

(defun ten2six (time / x)
	(* time 60)
)

(defun ten2time(time / hrs mins)
	(setq hrs (fix time))
	(setq mins (- time hrs))
	(setq mins (* 60 mins))
	(setq mins (round mins 1))
	(setq time (strcat (itoa hrs) "h " (itoa mins) "min "))
)

(defun round (cislo presnost)
	(* presnost
		(if (minusp cislo)
			(fix (- (/ cislo presnost) 0.5))
			(fix (+ (/ cislo presnost) 0.5))
		)
	)
)

(defun deg2rad (degree / x)
	(* (/ degree 180) pi)
)

(defun rad2deg (radian / x)
	(* (/ radian pi) 180)
)

(defun asin (x)
	(atan x (sqrt (- 1 (expt x 2))))
)

(defun acos (x)
	(atan (sqrt (- 1 (expt x 2))) x)
)


(defun line_x_plane (lp1 lp2 pp1 pp2 pp3 / lp1x lp1y lp1z lp2x lp2y lp2z pp1x pp1y pp1z pp2x pp2y pp2z pp3x pp3y pp3z ldx ldy ldz a b c d tt numerator denominator intersection intx inty intz)
  
	; line variables l
	; plane variables p
	; delta (vector) values d
	
	; get coordinate values
	(setq
	lp1x (car lp1)
	lp1y (cadr lp1)
	lp1z (caddr lp1)
	lp2x (car lp2)
	lp2y (cadr lp2)
	lp2z (caddr lp2)
	pp1x (car pp1)
	pp1y (cadr pp1)
	pp1z (caddr pp1)
	pp2x (car pp2)
	pp2y (cadr pp2)
	pp2z (caddr pp2)
	pp3x (car pp3)
	pp3y (cadr pp3)
	pp3z (caddr pp3)
	)
	
	; calculate values for plane equation: ax + by + cz + d = 0
	; [a, b, c] is plane normal vector
	(setq a (- (* (- pp2y pp1y) (- pp3z pp1z)) (* (- pp3y pp1y) (- pp2z pp1z))))
	(setq b (- (* (- pp2z pp1z) (- pp3x pp1x)) (* (- pp3z pp1z) (- pp2x pp1x))))
	(setq c (- (* (- pp2x pp1x) (- pp3y pp1y)) (* (- pp3x pp1x) (- pp2y pp1y))))
	(setq d (* -1 (+ (* a pp1x) (* b pp1y) (* c pp1z))))
	
	; suppose line equation:
	; x = lp1x + ldx * t
	; y = lp1y + ldy * t
	; z = lp1z + ldz * t
	
	; calculate line vector
	(setq
	ldx (- lp2x lp1x)
	ldy (- lp2y lp1y)
	ldz (- lp2z lp1z)
	)
	
	; substitute line equation to vector equation and calculate t value
	; if numerator is 0 then lp1 lies in the plane
	(setq numerator (+ (* a lp1x) (* b lp1y) (* c lp1z) d))
	; denominator is dot product of 2 vectors; if 0 then line is parallel with the plane
	(setq denominator (+ (* a ldx) (* b ldy) (* c ldz)))
	(if (equal denominator 0 0.0001)
		(progn
			(if (equal numerator 0 0.0001)
				(progn
				;(princ "\nLine is coplanar with the plane")
				(setq intersection (list -2))
				)
				(progn
				;(princ "\nLine is parallel with the plane")
				(setq intersection (list -1))
				)
			)
		)
		(progn
			(setq tt (* -1 (/ numerator denominator)))
			; calculate intersection point
			(setq intx (+ lp1x (* ldx tt)))
			(setq inty (+ lp1y (* ldy tt)))
			(setq intz (+ lp1z (* ldz tt)))
			(setq intersection (list intx inty intz))
		)
	)
	
)

; Area of a triangle according to Heron's formula
(defun triarea ( p1 p2 p3 / side1 side2 side3 p area)

	(setq
	side1 (distance p1 p2)
	side2 (distance p2 p3)
	side3 (distance p3 p1)
	)
	
	; get half of triangle perimeter
	(setq p (/ (+ side1 side2 side3) 2))
	
	; calculate triangle area
	(setq a (sqrt (* p (- p side1) (- p side2) (- p side3))))
)

; Test if a point in triangle's plane is inside the triangle
(defun inside_triangle ( p0 pp1 pp2 pp3 / aarea alpha beta gama)
	
	; get triangle area
	(setq aarea (triarea pp1 pp2 pp3))

	(setq alpha (/ (triarea p0 pp1 pp2) aarea))
	(setq beta (/ (triarea p0 pp2 pp3) aarea))
	(setq gama (/ (triarea p0 pp1 pp3) aarea))
	
	;;(setq gama (- 1 (+ alpha beta)))
	
	(if (= (and (>= alpha 0) (<= alpha 1)) (and (>= beta 0) (<= beta 1)) (and (>= gama 0) (<= gama 1)) (equal (+ alpha beta gama) 1 0.0001) (= 1 1))
		(progn
			;(princ "\nPoint is inside the triangle")
			(setq prunik 1)
		)
		(progn
			;(princ "\nPoint is outside the triangle")
			(setq prunik 0)
		)
	)
	
)

(defun ray_x_segment(ray1 ray2 seg1 seg2 / a b c d e f t u 
numerator1 denominator1 numerator2 denominator2 numerator3 denominator3 
intx inty intz minx maxx miny maxy minz maxz)
	
	(setq
	a (- (car ray2) (car ray1))
	b (- (cadr ray2) (cadr ray1))
	c (- (caddr ray2) (caddr ray1))
	d (- (car seg2) (car seg1))
	e (- (cadr seg2) (cadr seg1))
	f (- (caddr seg2) (caddr seg1))
	)
	
	; denominator
	(setq denominator1 (- (* a e) (* b d)))
	(setq denominator2 (- (* a f) (* c d)))
	(setq denominator3 (- (* b f) (* c e)))
	
	(if (> (abs denominator1) 0.0001)
	(progn
		(setq numerator1 (+ (* b (car seg1)) (* b (car ray1) -1) (* a (cadr seg1) -1) (* a (cadr ray1))))
		(setq u (/ numerator1 denominator1))
	))
	
	(if (> (abs denominator2) 0.0001)
	(progn
		(setq numerator2 (+ (* c (car seg1)) (* c (car ray1) -1) (* a (caddr seg1) -1) (* a (caddr ray1))))
		(setq u (/ numerator2 denominator2))
	))
	
	(if (> (abs denominator3) 0.0001)
	(progn
		(setq numerator3 (+ (* c (cadr seg1)) (* c (cadr ray1) -1) (* b (caddr seg1) -1) (* b (caddr ray1))))
		(setq u (/ numerator3 denominator3))
	))
	
	(setq
	intx (+ (car seg1) (* d u))
	inty (+ (cadr seg1) (* e u))
	intz (+ (caddr seg1) (* f u))
	)
	
	(if (< (car seg1) (car seg2))
	(progn
		(setq minx (car seg1))
		(setq maxx (car seg2))
	)
	(progn
		(setq minx (car seg2))
		(setq maxx (car seg1))
	)
	)
	
	(if (< (cadr seg1) (cadr seg2))
	(progn
		(setq miny (cadr seg1))
		(setq maxy (cadr seg2))
	)
	(progn
		(setq miny (cadr seg2))
		(setq maxy (cadr seg1))
	)
	)
	
	(if (< (caddr seg1) (caddr seg2))
	(progn
		(setq minz (caddr seg1))
		(setq maxz (caddr seg2))
	)
	(progn
		(setq minz (caddr seg2))
		(setq maxz (caddr seg1))
	)
	)
	
	(if
	(=
	(>= intx minx) (<= intx maxx)
	(>= inty miny) (<= inty maxy)
	(>= intz minz) (<= intz maxz)
	(= 1 1)
	)
		(progn
		;(princ "\nLine and segment intersect!")
		(setq prunik 1)
		)
		(progn
		;(princ "\nNo intersection!")
		(setq prunik 0)
		)
	)
	
	(princ)

)

(defun IntersLineTriangle ( p1 p2 p3 p4 p5 / ip)
  
	(setq ip (line_x_plane p1 p2 p3 p4 p5))
	(if (= (length ip) 3)
		(progn
      (setq prunik (inside_triangle ip p3 p4 p5))
		)
		(progn
		(if (= (car ip) -1) (setq prunik 0))
		(if (= (car ip) -2)
			(progn
				(setq prunik (ray_x_segment p1 p2 p3 p4))
				(if (= prunik 0) (setq prunik (ray_x_segment p1 p2 p4 p5)))
				(if (= prunik 0) (setq prunik (ray_x_segment p1 p2 p3 p5)))
			)
		)
		)
	)
)

(defun tangens (x)(/ (sin x)(cos x)))

(princ)